diff --git a/include/printf_buffer.h b/include/printf_buffer.h
index cee5afb581..a5483e8a97 100644
--- a/include/printf_buffer.h
+++ b/include/printf_buffer.h
@@ -206,6 +206,11 @@ bool __printf_buffer_flush (struct __printf_buffer *buf) attribute_hidden;
 void __vprintf_buffer (struct __printf_buffer *buf, const char *format,
                        va_list ap, unsigned int mode_flags) attribute_hidden;
 
+/* Write the argument list to BUF according to FORMAT.
+   Unconditionally enables fortification (special procesing for %n).  */
+void __printf_buffer (struct __printf_buffer *buf, const char *format, ...)
+  __attribute__ ((__format__ (__printf__, 2, 3))) attribute_hidden;
+
 /* Wide version of struct __printf_buffer follows.  */
 
 enum __wprintf_buffer_mode
diff --git a/stdio-common/Makefile b/stdio-common/Makefile
index 6447b6b444..d610ed67e6 100644
--- a/stdio-common/Makefile
+++ b/stdio-common/Makefile
@@ -64,6 +64,7 @@ routines := \
   perror \
   printf \
   printf-prs \
+  printf_buffer \
   printf_buffer_as_file \
   printf_buffer_done \
   printf_buffer_flush \
@@ -290,6 +291,10 @@ test-srcs = \
   tst-unbputc \
   # test-srcs
 
+# Test for the internal, non-exported __printf_buffer function.
+tests-internal += tst-printf_buffer
+tests-static += tst-printf_buffer
+
 ifeq ($(run-built-tests),yes)
 tests-special += \
   $(objpfx)tst-printf-bz18872-mem.out \
diff --git a/stdio-common/printf_buffer.c b/stdio-common/printf_buffer.c
new file mode 100644
index 0000000000..fabb3b5bb4
--- /dev/null
+++ b/stdio-common/printf_buffer.c
@@ -0,0 +1,30 @@
+/* Write a format string to a buffer.
+   Copyright (C) 2024 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <printf_buffer.h>
+#include <libioP.h>
+#include <stdarg.h>
+
+void
+__printf_buffer (struct __printf_buffer *buf, const char *format, ...)
+{
+  va_list arg;
+  va_start (arg, format);
+  __vprintf_buffer (buf, format, arg, PRINTF_FORTIFY);
+  va_end (arg);
+}
diff --git a/stdio-common/tst-printf_buffer.c b/stdio-common/tst-printf_buffer.c
new file mode 100644
index 0000000000..d12da8c939
--- /dev/null
+++ b/stdio-common/tst-printf_buffer.c
@@ -0,0 +1,138 @@
+/* Basic test for the __printf_buffer function (via asprintf).
+   Copyright (C) 2024 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <printf_buffer.h>
+#include <array_length.h>
+#include <string.h>
+#include <support/check.h>
+
+static int
+do_test (void)
+{
+  {
+    struct __printf_buffer_asprintf buf;
+    __printf_buffer_asprintf_init (&buf);
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    TEST_COMPARE (__printf_buffer_asprintf_free (&buf), -1);
+  }
+
+  {
+    struct __printf_buffer_asprintf buf;
+    __printf_buffer_asprintf_init (&buf);
+    __printf_buffer (&buf.base, "%s", "");
+    TEST_VERIFY (buf.base.write_base == buf.direct);
+    TEST_VERIFY (buf.base.write_ptr == buf.base.write_base);
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    TEST_COMPARE (__printf_buffer_asprintf_free (&buf), -1);
+  }
+
+  {
+    struct __printf_buffer_asprintf buf;
+    __printf_buffer_asprintf_init (&buf);
+    __printf_buffer (&buf.base, "abc");
+    TEST_VERIFY (buf.base.write_base == buf.direct);
+    TEST_VERIFY (buf.base.write_ptr == buf.base.write_base + 3);
+    TEST_COMPARE_BLOB (buf.direct, 3, "abc", 3);
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    TEST_COMPARE (__printf_buffer_asprintf_free (&buf), -1);
+  }
+
+  {
+    struct __printf_buffer_asprintf buf;
+    __printf_buffer_asprintf_init (&buf);
+    __printf_buffer (&buf.base, "abc[%d]DEF", 17);
+    TEST_VERIFY (buf.base.write_base == buf.direct);
+    TEST_VERIFY (buf.base.write_ptr == buf.base.write_base + 10);
+    TEST_COMPARE_BLOB (buf.direct, 10, "abc[17]DEF", 10);
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    TEST_COMPARE (__printf_buffer_asprintf_free (&buf), -1);
+  }
+
+  /* Test concatenation.  */
+  {
+    struct __printf_buffer_asprintf buf;
+    __printf_buffer_asprintf_init (&buf);
+    __printf_buffer (&buf.base, "abc");
+    TEST_VERIFY (buf.base.write_base == buf.direct);
+    TEST_VERIFY (buf.base.write_ptr == buf.base.write_base + 3);
+    TEST_COMPARE_BLOB (buf.direct, 3, "abc", 3);
+    __printf_buffer (&buf.base, "[%d]DEF", 17);
+    TEST_VERIFY (buf.base.write_base == buf.direct);
+    TEST_VERIFY (buf.base.write_ptr == buf.base.write_base + 10);
+    TEST_COMPARE_BLOB (buf.direct, 10, "abc[17]DEF", 10);
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    TEST_COMPARE (__printf_buffer_asprintf_free (&buf), -1);
+  }
+
+  {
+    struct __printf_buffer_asprintf buf;
+    char large_string[500];
+    memset (large_string, 'X', array_length (large_string));
+    large_string[array_length (large_string) -1] = '\0';
+    int n;
+
+    __printf_buffer_asprintf_init (&buf);
+    __printf_buffer (&buf.base, "%s", large_string);
+    TEST_VERIFY (buf.base.write_base != buf.direct);
+    TEST_COMPARE_BLOB (buf.base.write_base,
+                       buf.base.write_ptr - buf.base.write_base,
+                       large_string, strlen (large_string));
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    TEST_COMPARE (__printf_buffer_asprintf_free (&buf), -1);
+
+    __printf_buffer_asprintf_init (&buf);
+    __printf_buffer (&buf.base, "abc");
+    __printf_buffer (&buf.base, "%n", &n);
+    /* %n counts from the start of the buffer, not from within the
+        printf call.  */
+    TEST_COMPARE (n, 3);
+    __printf_buffer (&buf.base, "%s", large_string);
+    TEST_VERIFY (buf.base.write_base != buf.direct);
+    TEST_COMPARE_BLOB (buf.base.write_base, 3, "abc", 3);
+    TEST_COMPARE_BLOB (buf.base.write_base + 3,
+                       buf.base.write_ptr - buf.base.write_base - 3,
+                       large_string, strlen (large_string));
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    __printf_buffer (&buf.base, "%n", &n);
+    TEST_COMPARE (n, 3 + strlen (large_string));
+    TEST_COMPARE_BLOB (buf.base.write_base, 3, "abc", 3);
+    TEST_COMPARE_BLOB (buf.base.write_base + 3,
+                       buf.base.write_ptr - buf.base.write_base - 3,
+                       large_string, strlen (large_string));
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    TEST_COMPARE (__printf_buffer_asprintf_free (&buf), -1);
+  }
+
+  /* Test %n with concatenation.  */
+  {
+    struct __printf_buffer_asprintf buf;
+    __printf_buffer_asprintf_init (&buf);
+    __printf_buffer (&buf.base, "abc");
+    int n = -1;
+    __printf_buffer (&buf.base, "D%nEF", &n);
+    TEST_COMPARE (n, 4);        /* %n counts from the start of the buffer.  */
+    TEST_VERIFY (buf.base.write_base == buf.direct);
+    TEST_COMPARE_BLOB (buf.base.write_base,
+                       buf.base.write_ptr - buf.base.write_base, "abcDEF", 6);
+    TEST_VERIFY (!__printf_buffer_has_failed (&buf.base));
+    TEST_COMPARE (__printf_buffer_asprintf_free (&buf), -1);
+  }
+  return 0;
+}
+
+#include <support/test-driver.c>